# ----------------------------
#    Compiler configuration
# ----------------------------

# C configuration
CC       = gcc
CFLAGS   = -O2 -Wall -march=native -fopenmp -D CUDA_ARCH=500

# C++ configuration
CXX      = g++
CXXFLAGS = -O2 -Wall -march=native --std=c++0x -fopenmp $(IDIRS) -D CUDA_ARCH=500

# CPP configuration
CPPFLAGS = -DNDEBUG

# NVCC configuration
NVFLAGS  = -use_fast_math --gpu-architecture=compute_50 --gpu-code=sm_50 -D CUDA_ARCH=500

# ----------------------------
#    Default directories
# ----------------------------

# Cuda directories
CUDA_HOME = /usr/local/cuda-6.5
CUDALIB  = $(CUDA_HOME)/lib64
CUDAINC  = $(CUDA_HOME)/include

# Additional include directories
IDIRS    = -I. -I.. -I$(CUDAINC) -I../..
WIN95LIB = ./lib

# ----------------------------
#    Linker options
# ----------------------------

# Linker flags
LDFLAGS  = -Wl,--no-as-needed -L$(CUDALIB) -L/usr/lib64 -lcudart -lcuda -lcufft -lnufft -fopenmp -openmp -lcusparse -lm -lstdc++


#In case of compiling with Windows, add
#-L$(WIN95LIB) after -L$(CUDALIB)
#in the Liker flags line.
